#include "vector.h"//use vectors
#include "curses.h"//use cursors
#include <windows.h>//use windows functions
#include <string.h>//use string operators

//we want to use vectors from the standard namespace
using std::vector;

//RANDOM NUMBER FUNCTIONS AND VARIABLES
void r_num(void);
unsigned long random(unsigned long max);
unsigned long seed;

//AUXILARY CURSES FUNCTIONS AND VARIABLES
	//MOSTLY TO AVOID SCREEN FLICKER
void prepare_curses(void);
void move_screen(int x,int y);//auxiliary locate function
void addch_screen(unsigned char c);//aux character drawer
void set_color_screen(unsigned char f,unsigned char b,unsigned char br); //aux color setting
void addstr_screen(char *str);//aux string displayer
void set_color(short f,short b,char bright);//basic color setter
void translategetch(char &c);//reads in values arrows even w/out numlock
int location[2]={0,0}; //the aux cursor position
unsigned char curcolor[3];//the aux color
unsigned char screen[80][25][4];//the auxiliary anti-flicker buffer

//GAME STRUCTURES AND VARIABLES

//Projectiles
struct projst
{
	int x,y;
	int vx,vy;
	int phasemax;
	int phase;
	unsigned char c[4];
};

//HERE IS A VECTOR (DYNAMIC ARRAY) THAT IS
	//A LOT OF POINTERS TO PROJECTILES
		//ANY OBJECTS OTHER THAN int, ETC. MUST BE DONE
		//AS POINTERS.  THEREFORE, THE FOLLOWING IS LEGAL
			//vector<int> proj;
		//BUT THE NEXT ONE IS NOT LEGAL
			//vector<projst> proj;
vector<projst *> proj;

//Bad creatures
enum EvilTypes
{
	EVIL_SINNER_TORMENTED,
	EVIL_DEMON_SHIT,
	EVIL_DEVIL_BARBED,
	EVIL_SATAN,
	EVILNUM
};

struct evilst
{
	int x,y;
	int type;
	int phase;
};

vector<evilst *> evil;

//Your level and location
int level=1,yourx,youry;

//The game map
unsigned char map[80][25][4];

void makemap(void);//create the map
short obstacle(int x,int y,char checkyou);//see if a square is blocked
char leveldone(void);//is the level completed?

int main(int argc, char* argv[])
{
	//start curses
	prepare_curses();

	//set up random numbers
	seed=GetTickCount();
	
	//title screen
	erase();

	char str[100];

	set_color(COLOR_WHITE,COLOR_BLACK,1);
	strcpy(str,"Blood Cave of Satan");
	move(4,39-(strlen(str)>>1));
	addstr(str);

	set_color(COLOR_WHITE,COLOR_BLACK,1);
	move(8,15);
	addch(1);
	set_color(COLOR_WHITE,COLOR_BLACK,1);
	addstr(" - Soul from Heaven (You)");

	set_color(COLOR_BLACK,COLOR_BLACK,1);
	move(9,15);
	addch(2);
	set_color(COLOR_WHITE,COLOR_BLACK,1);
	addstr(" - Soul in Hell");

	set_color(COLOR_MAGENTA,COLOR_BLACK,1);
	move(10,15);
	addch('@');
	set_color(COLOR_WHITE,COLOR_BLACK,1);
	addstr(" - Tormented Sinner");

	set_color(COLOR_YELLOW,COLOR_BLACK,0);
	move(8,50);
	addch(157);
	set_color(COLOR_WHITE,COLOR_BLACK,1);
	addstr(" - Shit Demon");

	set_color(COLOR_YELLOW,COLOR_BLACK,1);
	move(9,50);
	addch(157);
	set_color(COLOR_WHITE,COLOR_BLACK,1);
	addstr(" - Barbed Devil");

	set_color(COLOR_RED,COLOR_BLACK,1);
	move(10,50);
	addch(157);
	set_color(COLOR_WHITE,COLOR_BLACK,1);
	addstr(" - Satan (The Evil One!)");

	set_color(COLOR_WHITE,COLOR_BLACK,1);
	strcpy(str,"Copyright (C) 2002, Tarn Adams");
	move(13,39-(strlen(str)>>1));
	addstr(str);
	strcpy(str,"A Bay 12 Games Production");
	move(14,39-(strlen(str)>>1));
	addstr(str);
	strcpy(str,"www.bay12games.com");
	move(15,39-(strlen(str)>>1));
	addstr(str);
	strcpy(str,"Use the arrow keys to move.  Use Q, W, E, A, S, D, Z, X, and C to fire.");
	move(18,39-(strlen(str)>>1));
	addstr(str);
	strcpy(str,"Collect souls of your family members in Hell.");
	move(19,39-(strlen(str)>>1));
	addstr(str);
	strcpy(str,"Press ESC at any time to quit.");
	move(20,39-(strlen(str)>>1));
	addstr(str);
	strcpy(str,"Press any other key now to challenge Satan in the name of God.");
	move(22,39-(strlen(str)>>1));
	addstr(str);

	char c=getch();
	if(c==27)//27 is ESCAPE
		{
		endwin();
		exit(0);
		}

	//begin the game loop

	nodelay(stdscr,TRUE);//this makes it real time

	//make map
	level=1;
	makemap();

	erase();//clears screen

	short youmovephase=0;

	unsigned long score=0;

	char youdead=0;

	do
		{
		unsigned long time=GetTickCount();

		//MOVE STUFF
			//WE START FROM THE BACK IN CASE
				//ONE OF THEM IS DELETED ALONG THE WAY
		for(int p=proj.size()-1;p>=0;p--)
			{
			//IF IT IS TIME TO MOVE, DO IT
			if(proj[p]->phase==0)
				{
				proj[p]->x+=proj[p]->vx;
				proj[p]->y+=proj[p]->vy;
				}

			//UPDATE PROJECTILE PHASES
			proj[p]->phase=(proj[p]->phase+1)%proj[p]->phasemax;

			//DO COLLISION DETECTION ON YOU
			if(proj[p]->x==yourx&&proj[p]->y==youry)
				{
				youdead=1;
				delete proj[p];
				proj.verase(p);
				break;
				}

			//DO COLLISION DETECTION ON CREATURES
			char delproj=0;
			for(int e=evil.size()-1;e>=0;e--)
				{
				if(proj[p]->x==evil[e]->x&&
					proj[p]->y==evil[e]->y)
					{
					//CHECK FOR IMMUNITY
						//shit demons immune to shit
					if(proj[p]->c[0]=='&'&&
						evil[e]->type==EVIL_DEMON_SHIT)continue;
						//satan cannot be killed
					if(evil[e]->type==EVIL_SATAN)continue;

					delete evil[e];
					evil.verase(e);
					delproj=1;
					}
				}
			if(delproj)
				{
				delete proj[p];
				proj.verase(p);
				continue;
				}

			//DO COLLISION DETECTION ON BOUNDARY
			if(proj[p]->x<0||
				proj[p]->y<0||
				proj[p]->x>=80||
				proj[p]->y>=25)
				{
				//MUST NUKE PROJ BEFORE WE ERASE IT FROM ARRAY
				delete proj[p];
				//NOW THIS REMOVES IT FROM THE vector
				proj.verase(p);
				//NOW JUMP TO NEXT ONE IN LOOP
				continue;
				}
			//DO COLLISION DETECTION ON WALLS
			else if(obstacle(proj[p]->x,proj[p]->y,0))
				{
				if(proj[p]->c[0]!='&')
					{
					switch(map[proj[p]->x][proj[p]->y][0])
						{
						//NON-FECAL PROJECTILES DEGRADE WALLS
						case 219:map[proj[p]->x][proj[p]->y][0]=178;break;
						case 178:map[proj[p]->x][proj[p]->y][0]=177;break;
						case 177:map[proj[p]->x][proj[p]->y][0]=176;break;
						case 176:
							//SATAN'S BULLETS CAN DESTROY WALLS
							if(proj[p]->c[0]=='*'&&
								proj[p]->x!=0&&proj[p]->x!=79&&
								proj[p]->y!=0&&proj[p]->y!=24)
								{
								map[proj[p]->x][proj[p]->y][0]=' ';
								}
							break;
						}
					}
				else
					{
					//THE SHIT SPLATTERS ON THE WALLS
					map[proj[p]->x][proj[p]->y][1]=proj[p]->c[1];
					map[proj[p]->x][proj[p]->y][2]=proj[p]->c[2];
					map[proj[p]->x][proj[p]->y][3]=proj[p]->c[3];
					}

				delete proj[p];
				proj.verase(p);
				continue;
				}
			}

		if(youdead)break;//drop out if you were wasted

			//MOVE THE CREATURES
		short esx,esy,phasemax,smart,eproj[4],eprojchance,eprojpm;
		for(int e=evil.size()-1;e>=0;e--)
			{
			//REMOVE THOSE MARKED FOR DEATH
			if(evil[e]->phase==-1)
				{
				delete evil[e];
				evil.verase(e);
				continue;
				}

			switch(evil[e]->type)
				{
				case EVIL_SINNER_TORMENTED:
					phasemax=100;smart=0;
					eproj[0]=0;
					break;
				case EVIL_DEMON_SHIT:
					phasemax=50;smart=0;
					eproj[0]='&';
					eproj[1]=COLOR_YELLOW;
					eproj[2]=COLOR_BLACK;
					eproj[3]=0;
					eprojchance=20;
					eprojpm=15;
					break;
				case EVIL_DEVIL_BARBED:
					phasemax=30;smart=1;
					eproj[0]=0;
					break;
				case EVIL_SATAN:
					phasemax=75;smart=1;
					eproj[0]='*';
					eproj[1]=COLOR_RED;
					eproj[2]=COLOR_BLACK;
					eproj[3]=0;
					eprojchance=5;
					eprojpm=8;
					break;
				}

			evil[e]->phase=(evil[e]->phase+1)%phasemax;

			if(evil[e]->phase==0)
				{
				esx=random(3)-1;
				esy=random(3)-1;

				if(smart)
					{
					if(yourx>evil[e]->x)esx=1;
					if(yourx<evil[e]->x)esx=-1;
					if(youry>evil[e]->y)esy=1;
					if(youry<evil[e]->y)esy=-1;
					}

				short o=obstacle(evil[e]->x+esx,evil[e]->y+esy,0);

				char pass=0;
				//RUN THINGS OVER
				if(o>0)
					{
					int targ=o-1;
					int targtype=evil[targ]->type;

					switch(evil[e]->type)
						{
						case EVIL_DEVIL_BARBED:
							if(targtype==EVIL_SINNER_TORMENTED)
								{
								evil[targ]->phase=-1;
								}
							break;
						case EVIL_SATAN:
							evil[targ]->phase=-1;
							break;
						}

					if(evil[targ]->phase==-1)pass=1;
					}
				else if(o&&smart)
					{
					if(esx!=0&&esy!=0)
						{
						if(!random(2))esx=0;
						else esy=0;
						}
					else
						{
						if(!random(2)&&esx==0)esx=random(3)-1;
						else if(esy==0)esy=random(3)-1;
						}

					o=obstacle(evil[e]->x+esx,evil[e]->y+esy,0);
					}

				//MOVE
				if(!o||pass)
					{
					if(evil[e]->type==EVIL_DEMON_SHIT&&
						map[evil[e]->x][evil[e]->y][0]!=2)
						{
						switch(random(3))
							{
							case 0:map[evil[e]->x][evil[e]->y][0]='%';break;
							case 1:map[evil[e]->x][evil[e]->y][0]='.';break;
							case 2:map[evil[e]->x][evil[e]->y][0]='#';break;
							}
						map[evil[e]->x][evil[e]->y][1]=COLOR_YELLOW;
						map[evil[e]->x][evil[e]->y][2]=COLOR_BLACK;
						map[evil[e]->x][evil[e]->y][3]=0;
						}

					evil[e]->x+=esx;
					evil[e]->y+=esy;

					if(yourx==evil[e]->x&&
						youry==evil[e]->y)
						{
						youdead=1;
						break;
						}
					}
				}

			if(eproj[0]&&!random(eprojchance))
				{
				projst *newp=new projst;
					newp->phase=0;
					newp->phasemax=eprojpm;
					do
						{
						newp->vx=random(3)-1;
						newp->vy=random(3)-1;
						}while(newp->vx==0&&newp->vy==0);
					newp->x=evil[e]->x;
					newp->y=evil[e]->y;
					newp->c[0]=eproj[0];
					newp->c[1]=eproj[1];
					newp->c[2]=eproj[2];
					newp->c[3]=eproj[3];
				proj.push_back(newp);
				}
			}

		for(e=evil.size()-1;e>=0;e--)
			{
			//REMOVE THOSE MARKED FOR DEATH
			if(evil[e]->phase==-1)
				{
				delete evil[e];
				evil.verase(e);
				continue;
				}
			}

		if(youdead)break;

		//PRINT STUFF
			//THIS IS THE KEY STATEMENT.
			//IF YOU JUST USE THE CURSES erase() COMMAND
				//IT WILL CAUSE THE SCREEN TO FLICKER
				//BECAUSE ALL SQUARES CHANGE VALUE TO ZERO
				//AND THEN BACK TO WHATEVER YOU PRINT THEM AS
		memmove(screen,map,80*25*4);

			//PRINT PROJECTILES
		for(p=0;p<proj.size();p++)
			{
			move_screen(proj[p]->x,proj[p]->y);
			set_color_screen(proj[p]->c[1],proj[p]->c[2],proj[p]->c[3]);
			addch_screen(proj[p]->c[0]);
			}

			//PRINT EVIL
		for(e=0;e<evil.size();e++)
			{
			move_screen(evil[e]->x,evil[e]->y);
			switch(evil[e]->type)
				{
				case EVIL_SINNER_TORMENTED:
					set_color_screen(COLOR_MAGENTA,COLOR_BLACK,1);
					addch_screen('@');
					break;
				case EVIL_DEMON_SHIT:
					set_color_screen(COLOR_YELLOW,COLOR_BLACK,0);
					addch_screen(157);
					break;
				case EVIL_DEVIL_BARBED:
					set_color_screen(COLOR_YELLOW,COLOR_BLACK,1);
					addch_screen(157);
					break;
				case EVIL_SATAN:
					set_color_screen(COLOR_RED,COLOR_BLACK,1);
					addch_screen(157);
					break;
				}
			}

			//PRINT YOUR GUY
		set_color_screen(COLOR_WHITE,COLOR_BLACK,1);
		move_screen(yourx,youry);
		addch_screen(1);

			//PRINT YOUR SCORE
		set_color_screen(COLOR_WHITE,COLOR_BLACK,1);
		char str[80],num[20];
		strcpy(str,"Score: ");
		itoa(score,num,10);
		strcat(str,num);
		move_screen(1,0);
		addstr_screen(str);

		if(level%10!=0)
			{
			strcpy(str,"Circle: ");
			itoa(level%10,num,10);
			strcat(str,num);
			move_screen(35,0);
			addstr_screen(str);
			}
		else
			{
			strcpy(str,"Satan's Lair");
			move_screen(34,0);
			addstr_screen(str);
			}

		if((level-1)/10>0)
			{
			int cycle=(level-1)/10;

			if(cycle>=1&&cycle<=5)
				{
				for(int x=1;x<=cycle;x++)
					{
					move_screen(68+x*2,0);
					addch_screen(197);
					}
				}
			else
				{
				move_screen(70,0);
				addch_screen(197);

				move_screen(71,0);
				addch_screen(' ');

				itoa(cycle,str,10);
				move_screen(72,0);
				addstr_screen(str);
				}
			}

		//NOW MAKE CURSES PRINT THE screen BUFFER
			//TO AVOID FLICKER
		int px,py;
		for(px=0;px<80;px++)
			{
			for(py=0;py<25;py++)
				{
				move(py,px);
				set_color(screen[px][py][1],screen[px][py][2],screen[px][py][3]);
				addch(screen[px][py][0]);
				}
			}

		refresh();

		//PROCESS INPUT
			//LOOK FOR A NEW KEY IN THE BUFFER
		char c=getch();

		//WHEN YOU PRESS ESCAPE, BAIL
			//(27 = ESC, 32 = SPACE, 10 = ENTER)
		if(c==27)break;

		//MUST USE THESE KEY FUNCTIONS
			//BECAUSE WE WANT TO FEEL IF SOMEBODY
			//IS HOLDING A KEY DOWN RIGHT WHEN IT HAPPENS

		//MOVE YOUR GUY
		if(youmovephase==0)
			{
			//THIS IS NOT ALWAYS RELIABLE
				//IT STICKS SOMETIMES ON MY COMPUTER
					//YOU CAN ALSO USE getch()
			short left=GetKeyState(VK_LEFT)>>1;
			short right=GetKeyState(VK_RIGHT)>>1;
			short up=GetKeyState(VK_UP)>>1;
			short down=GetKeyState(VK_DOWN)>>1;
			short pgup=GetKeyState(VK_PRIOR)>>1;
			short pgdn=GetKeyState(VK_NEXT)>>1;
			short home=GetKeyState(VK_HOME)>>1;
			short end=GetKeyState(VK_END)>>1;

			short sx=0,sy=0;
			if(left||home||end)sx--;
			if(right||pgup||pgdn)sx++;
			if(up||pgup||home)sy--;
			if(down||pgdn||end)sy++;

			if(sx!=0||sy!=0)
				{
				yourx+=sx;
				youry+=sy;

				if(obstacle(yourx,youry,0))
					{
					yourx-=sx;
					youry-=sy;
					}
				else
					{
					if(map[yourx][youry][0]==2)
						{
						map[yourx][youry][0]=' ';
						score+=500;

						if(leveldone())
							{
							level++;
							makemap();
							}
						}
					else if((map[yourx-sx][youry-sy][0]=='#'||
						map[yourx-sx][youry-sy][0]=='.'||
						map[yourx-sx][youry-sy][0]=='%')&&!random(2))
						{
						switch(random(3))
							{
							case 0:map[yourx][youry][0]='%';break;
							case 1:map[yourx][youry][0]='.';break;
							case 2:map[yourx][youry][0]='#';break;
							}
						map[yourx][youry][1]=COLOR_YELLOW;
						map[yourx][youry][2]=COLOR_BLACK;
						map[yourx][youry][3]=0;
						}
					}
				}

			//FIRE IF PRESSING A BUTTON
				//THIS IS NOT ALWAYS RELIABLE
					//IT STICKS SOMETIMES ON MY COMPUTER
			short key_w=GetKeyState('W')>>1;
			short key_a=GetKeyState('A')>>1;
			short key_x=GetKeyState('X')>>1;
			short key_d=GetKeyState('D')>>1;
			short key_q=GetKeyState('Q')>>1;
			short key_e=GetKeyState('E')>>1;
			short key_z=GetKeyState('Z')>>1;
			short key_c=GetKeyState('C')>>1;

			sx=0;sy=0;
			if(key_a||key_q||key_z)sx--;
			if(key_d||key_e||key_c)sx++;
			if(key_w||key_e||key_q)sy--;
			if(key_x||key_c||key_z)sy++;

			if(sx!=0||sy!=0)
				{
				//WE MUST MAKE A NEW PROJECTILE TO FEED TO THE vector
				projst *newp=new projst;
					newp->x=yourx;
					newp->y=youry;
					newp->vx=sx;
					newp->vy=sy;
					newp->phase=0;
					newp->phasemax=1;
					newp->c[0]=197;
					newp->c[1]=COLOR_CYAN;
					newp->c[2]=COLOR_BLACK;
					newp->c[3]=1;
				//THIS COMMAND STICKS IT ON THE BACK OF THE vector ARRAY
				proj.push_back(newp);
				}
			}

		//DELAY AT LEAST 10 milliseconds SO IT DOESN'T GO TOO FAST
			//THE SECOND CONDITION IS IN CASE GetTickCount() WRAPS TO ZERO
				//EVEN IF THIS ONLY HAPPENS ONCE EVERY 47 DAYS OR WHATEVER
		while(time>GetTickCount()-10&&GetTickCount()>=time);

		//CHANGE YOUR PHASE
			//THIS KEEPS YOU FROM MOVING TOO FAST
				//ie YOU CAN ONLY MOVE ON PHASE ZERO
		youmovephase=(youmovephase+1)%5;

		//TAKE AWAY POINTS IF YOU ARE TAKING TIME
		if(youmovephase==0&&score>0)score--;

		}while(1);

	//clean the proj array
	for(int pr=0;pr<proj.size();pr++)
		{
		delete proj[pr];
		}
	proj.clear();

	//clean the evil array
	for(int e=0;e<evil.size();e++)
		{
		delete evil[e];
		}
	evil.clear();

	//turn delay back on so it will pause for the game over message
	nodelay(stdscr,FALSE);

	do
		{
		int ymove=0;
		if(youry>12)ymove=-5;
		else ymove=5;

		set_color(COLOR_RED,COLOR_BLACK,1);

		move(11+ymove,33);
		addstr("-------------");
		move(12+ymove,33);
		addstr("| GAME OVER |");
		move(13+ymove,33);
		addstr("-------------");

		refresh();

		c=getch();
		if(c==27||c==32||c==10)break;
		}while(1);

	//deinitialize curses
	endwin();

	return 0;
}

void makemap(void)
{
	//CLEAR ARRAYS
		//clean the proj array
	for(int pr=0;pr<proj.size();pr++)
		{
		delete proj[pr];
		}
	proj.clear();

		//clean the evil array
	for(int e=0;e<evil.size();e++)
		{
		delete evil[e];
		}
	evil.clear();

	//MAKE WALLS
	for(int x=0;x<80;x++)
		{
		for(int y=0;y<25;y++)
			{
			if(x==0||y==0||x==79||y==24)map[x][y][0]=219;
			else map[x][y][0]=' ';
			map[x][y][1]=COLOR_RED;
			map[x][y][2]=COLOR_BLACK;
			map[x][y][3]=0;
			}
		}

	switch((level-1)%10)
		{
		case 0:
			{
			for(int x=0;x<80;x++)
				{
				for(int y=0;y<25;y++)
					{
					if((x==19||x==60)&&(y<=6||y>=18))map[x][y][0]=219;
					if((y==8||y==16)&&(x<=17||x>=62))map[x][y][0]=219;
					}
				}
			break;
			}
		case 1:
			{
			for(int x=0;x<80;x++)
				{
				if(x==19||x==60)continue;
				map[x][3][0]=219;
				map[x][21][0]=219;
				}
			map[39][1][0]=219;
			map[39][2][0]=219;
			map[40][1][0]=219;
			map[40][2][0]=219;
			map[39][22][0]=219;
			map[39][23][0]=219;
			map[40][22][0]=219;
			map[40][23][0]=219;
			break;
			}
		case 2:
			{
			for(int y=2;y<23;y++)
				{
				map[19][y][0]=219;
				map[34][y][0]=219;
				map[45][y][0]=219;
				map[60][y][0]=219;
				}
			break;
			}
		case 3:
			{
			for(int x=2;x<78;x++)
				{
				if(x==7||x==73)continue;
				if(x==12||x==68)continue;
				if(x==17||x==63)continue;
				if(x==22||x==58)continue;
				if(x==27||x==53)continue;
				if(x==32||x==48)continue;
				if(x==37||x==43)continue;

				map[x][2][0]=219;
				map[x][6][0]=219;
				map[x][10][0]=219;
				map[x][14][0]=219;
				map[x][18][0]=219;
				map[x][22][0]=219;
				}
			break;
			}
		case 5:
			{
			map[20][15][0]=219;
			map[21][15][0]=219;
			map[20][14][0]=219;

			map[30][5][0]=219;
			map[31][5][0]=219;
			map[30][4][0]=219;

			map[60][7][0]=219;
			map[61][7][0]=219;
			map[60][8][0]=219;

			map[40][2][0]=219;
			map[41][2][0]=219;
			map[40][3][0]=219;

			map[51][9][0]=219;
			map[50][9][0]=219;
			map[50][8][0]=219;

			map[30][15][0]=219;
			map[31][15][0]=219;
			map[30][14][0]=219;

			map[60][17][0]=219;
			map[61][17][0]=219;
			map[60][18][0]=219;

			map[40][17][0]=219;
			map[41][17][0]=219;
			map[40][18][0]=219;

			map[51][19][0]=219;
			map[50][19][0]=219;
			map[50][18][0]=219;

			break;
			}
		case 6:
			{
			map[1][2][0]=219;
			map[2][2][0]=219;
			map[3][2][0]=219;
			map[4][2][0]=219;
			map[4][3][0]=219;
			map[4][4][0]=219;

			map[77][1][0]=219;
			map[77][2][0]=219;
			map[77][3][0]=219;
			map[77][4][0]=219;
			map[76][4][0]=219;
			map[75][4][0]=219;

			map[78][22][0]=219;
			map[77][22][0]=219;
			map[76][22][0]=219;
			map[75][22][0]=219;
			map[75][21][0]=219;
			map[75][20][0]=219;

			map[2][23][0]=219;
			map[2][22][0]=219;
			map[2][21][0]=219;
			map[2][20][0]=219;
			map[3][20][0]=219;
			map[4][20][0]=219;

			map[20][8][0]=219;
			map[59][8][0]=219;
			map[20][16][0]=219;
			map[59][16][0]=219;

			map[22][9][0]=219;
			map[57][9][0]=219;
			map[22][15][0]=219;
			map[57][15][0]=219;

			map[24][10][0]=219;
			map[55][10][0]=219;
			map[24][14][0]=219;
			map[55][14][0]=219;

			map[26][11][0]=219;
			map[53][11][0]=219;
			map[26][13][0]=219;
			map[53][13][0]=219;

			map[24][8][0]=219;
			map[55][8][0]=219;
			map[24][16][0]=219;
			map[55][16][0]=219;

			map[26][9][0]=219;
			map[53][9][0]=219;
			map[26][15][0]=219;
			map[53][15][0]=219;

			map[28][10][0]=219;
			map[51][10][0]=219;
			map[28][14][0]=219;
			map[51][14][0]=219;

			map[30][11][0]=219;
			map[49][11][0]=219;
			map[30][13][0]=219;
			map[49][13][0]=219;

			map[28][8][0]=219;
			map[51][8][0]=219;
			map[28][16][0]=219;
			map[51][16][0]=219;

			map[30][9][0]=219;
			map[49][9][0]=219;
			map[30][15][0]=219;
			map[49][15][0]=219;

			map[32][10][0]=219;
			map[47][10][0]=219;
			map[32][14][0]=219;
			map[47][14][0]=219;

			map[34][11][0]=219;
			map[45][11][0]=219;
			map[34][13][0]=219;
			map[45][13][0]=219;

			map[28][12][0]=219;
			map[32][12][0]=219;
			map[36][12][0]=219;

			map[51][12][0]=219;
			map[47][12][0]=219;
			map[43][12][0]=219;

			for(int x=24;x<=55;x++)
				{
				if(x==39||x==40)continue;
				map[x][8][0]=219;
				map[x][16][0]=219;
				}

			break;
			}
		case 7:
			{
			map[39][11][0]=219;
			map[41][13][0]=219;
			map[39][13][0]=219;
			map[41][11][0]=219;

			map[37][12][0]=219;
			map[40][15][0]=219;
			map[43][12][0]=219;
			map[40][9][0]=219;

			break;
			}
		case 9:
			map[38][10][0]=219;
			map[38][11][0]=219;
			map[38][13][0]=219;
			map[38][14][0]=219;
			map[42][10][0]=219;
			map[42][11][0]=219;
			map[42][13][0]=219;
			map[42][14][0]=219;
			map[39][10][0]=219;
			map[41][10][0]=219;
			map[39][14][0]=219;
			map[41][14][0]=219;

			map[10][6][0]=219;
			map[10][18][0]=219;
			map[69][6][0]=219;
			map[69][18][0]=219;

			map[20][6][0]=219;
			map[20][18][0]=219;
			map[59][6][0]=219;
			map[59][18][0]=219;

			map[30][6][0]=219;
			map[30][18][0]=219;
			map[49][6][0]=219;
			map[49][18][0]=219;

			map[10][10][0]=219;
			map[10][14][0]=219;
			map[69][10][0]=219;
			map[69][14][0]=219;

			map[20][10][0]=219;
			map[20][14][0]=219;
			map[59][10][0]=219;
			map[59][14][0]=219;

			map[30][10][0]=219;
			map[30][14][0]=219;
			map[49][10][0]=219;
			map[49][14][0]=219;
			break;
		}

	//PLACE YOU
	yourx=40;
	youry=12;

	//PLACE SOULS
	map[1][1][0]=2;
	map[1][1][1]=COLOR_BLACK;
	map[1][1][2]=COLOR_BLACK;
	map[1][1][3]=1;

	map[78][1][0]=2;
	map[78][1][1]=COLOR_BLACK;
	map[78][1][2]=COLOR_BLACK;
	map[78][1][3]=1;

	map[1][23][0]=2;
	map[1][23][1]=COLOR_BLACK;
	map[1][23][2]=COLOR_BLACK;
	map[1][23][3]=1;

	map[78][23][0]=2;
	map[78][23][1]=COLOR_BLACK;
	map[78][23][2]=COLOR_BLACK;
	map[78][23][3]=1;

	//PLACE EVIL
	evilst *newe;
	char conf;

	int types[EVILNUM];

	for(e=0;e<EVILNUM;e++)types[e]=0;

	switch((level-1)%10)
		{
		case 0:
			types[EVIL_SINNER_TORMENTED]=20;
			if(level>10)types[EVIL_SINNER_TORMENTED]=200;
			break;
		case 1:
			types[EVIL_SINNER_TORMENTED]=25;
			types[EVIL_DEVIL_BARBED]=5;
			if(level>10)
				{
				types[EVIL_SINNER_TORMENTED]=50;
				types[EVIL_DEVIL_BARBED]=20+level-2;
				if(types[EVIL_DEVIL_BARBED]>50)types[EVIL_DEVIL_BARBED]=50;
				}
			break;
		case 2:
			types[EVIL_SINNER_TORMENTED]=30;
			types[EVIL_DEMON_SHIT]=5;
			if(level>10)
				{
				types[EVIL_SINNER_TORMENTED]=55;
				types[EVIL_DEVIL_BARBED]=20+level-3;
				if(types[EVIL_DEVIL_BARBED]>50)types[EVIL_DEVIL_BARBED]=50;
				}
			break;
		case 3:
			types[EVIL_SINNER_TORMENTED]=35;
			types[EVIL_DEVIL_BARBED]=10;
			if(level>10)
				{
				types[EVIL_SINNER_TORMENTED]=75;
				types[EVIL_DEVIL_BARBED]=30+(level-4);
				if(types[EVIL_DEVIL_BARBED]>100)types[EVIL_DEVIL_BARBED]=100;
				}
			break;
		case 4:
			types[EVIL_SINNER_TORMENTED]=40;
			types[EVIL_DEVIL_BARBED]=15;
			if(level>10)
				{
				types[EVIL_SINNER_TORMENTED]=100;
				types[EVIL_DEVIL_BARBED]=40+(level-5);
				if(types[EVIL_DEVIL_BARBED]>125)types[EVIL_DEVIL_BARBED]=125;
				}
			break;
		case 5:
			types[EVIL_SINNER_TORMENTED]=50;
			types[EVIL_DEMON_SHIT]=10;
			if(level>10)
				{
				types[EVIL_SINNER_TORMENTED]=115;
				types[EVIL_DEVIL_BARBED]=30+(level-6);
				if(types[EVIL_DEVIL_BARBED]>100)types[EVIL_DEVIL_BARBED]=100;
				}
			break;
		case 6:
			types[EVIL_SINNER_TORMENTED]=60;
			types[EVIL_DEVIL_BARBED]=20;
			if(level>10)
				{
				types[EVIL_SINNER_TORMENTED]=125;
				types[EVIL_DEVIL_BARBED]=50+(level-7);
				if(types[EVIL_DEVIL_BARBED]>135)types[EVIL_DEVIL_BARBED]=135;
				}
			break;
		case 7:
			types[EVIL_SINNER_TORMENTED]=70;
			types[EVIL_DEMON_SHIT]=20;
			if(level>10)
				{
				types[EVIL_SINNER_TORMENTED]=130;
				types[EVIL_DEVIL_BARBED]=40+(level-8);
				if(types[EVIL_DEVIL_BARBED]>125)types[EVIL_DEVIL_BARBED]=125;
				}
			break;
		case 8:
			types[EVIL_SINNER_TORMENTED]=80;
			types[EVIL_DEVIL_BARBED]=30;
			if(level>10)
				{
				types[EVIL_SINNER_TORMENTED]=145;
				types[EVIL_DEVIL_BARBED]=60+(level-9);
				if(types[EVIL_DEVIL_BARBED]>145)types[EVIL_DEVIL_BARBED]=145;
				}
			break;
		case 9:
			types[EVIL_SINNER_TORMENTED]=100;
			types[EVIL_SATAN]=1;
			if(level>10)
				{
				types[EVIL_SINNER_TORMENTED]=150;
				types[EVIL_DEVIL_BARBED]=10+(level-10);
				if(types[EVIL_DEVIL_BARBED]>150)types[EVIL_DEVIL_BARBED]=150;

				if(level>20)
					{
					types[EVIL_DEMON_SHIT]=level-20;
					if(types[EVIL_DEMON_SHIT]>50)types[EVIL_DEMON_SHIT]=50;
					}
				}
			break;
		}

	int evilnum=1,etype;

	while(1)
		{
		etype=-1;

		for(int e=0;e<EVILNUM;e++)
			{
			if(types[e]>0)
				{
				etype=e;
				types[e]--;
				break;
				}
			}

		if(etype==-1)break;

		newe=new evilst;
		
			newe->type=etype;

			do
				{
				newe->x=random(78)+1;
				newe->y=random(23)+1;

				conf=1;

				if(obstacle(newe->x,newe->y,1))conf=0;
				if(abs(newe->x-yourx)<8&&abs(newe->y-youry)<6)conf=0;

				}while(!conf);
			newe->phase=random(100);

		evil.push_back(newe);
		}
}

short obstacle(int x,int y,char checkyou)
{
	if(x<0||y<0||x>=80||y>=25)return -1;

	switch(map[x][y][0])
		{
		case 219:
		case 178:
		case 177:
		case 176:
			return -2;
		}

	for(int e=0;e<evil.size();e++)
		{
		if(evil[e]->x==x&&evil[e]->y==y)return e+1;
		}

	if(yourx==x&&youry==y&&checkyou)return -3;

	return 0;
}

char leveldone(void)
{
	for(int x=0;x<80;x++)
		{
		for(int y=0;y<25;y++)
			{
			if(map[x][y][0]==2)return 0;
			}
		}

	return 1;
}

/////////////////////////////////////////////////////////////
//AUXILIARY CURSES COMMANDS
/////////////////////////////////////////////////////////////
//Curses starts to flicker even you draw the same characters to
//the screen.  Nothing would actually change, but curses will
//still update those positions.  So I made a buffer, and only
//update the screen using curses once.  This is only important
//for real-time games.

void move_screen(int x,int y)
{
	if(x<0)x=0;
	if(y<0)y=0;
	if(x>79)x=79;
	if(y>24)y=24;
	location[0]=x;
	location[1]=y;
}

void addch_screen(unsigned char c)
{
	screen[location[0]][location[1]][0]=c;
	screen[location[0]][location[1]][1]=curcolor[0];
	screen[location[0]][location[1]][2]=curcolor[1];
	screen[location[0]][location[1]][3]=curcolor[2];
}

void set_color_screen(unsigned char f,unsigned char b,unsigned char br)
{
	curcolor[0]=f;
	curcolor[1]=b;
	curcolor[2]=br;
}

void addstr_screen(char *str)
{
	int x=location[0];
	int y=location[1];

	for(int s=0;s<strlen(str)&&x<80;s++)
		{
		if(x<0)
			{
			s-=x;
			x=0;
			if(s>=strlen(str))break;
			}
		screen[x][y][0]=str[s];
		screen[x][y][1]=curcolor[0];
		screen[x][y][2]=curcolor[1];
		screen[x][y][3]=curcolor[2];
		x++;
		}
}

void prepare_curses(void)
{
	//start curses
	initscr();

	//initialize curses color
	start_color();

	//initialize the array of color pairs
	for(int i=0;i<8;i++)
		{
		for(int j=0;j<8;j++)
			{
			if(i==0&&j==0)
				{
				init_pair(7*8,0,0);
				continue;
				}
			if(i==7&&j==0)continue;
			init_pair(i*8+j,i,j);
			}
		}

	curs_set(0);//turns off cursor
	raw_output(TRUE);//this lets you print the lower ascii characters
	keypad(stdscr,TRUE);//this lets you use the keypad
}

//sets current color to desired setting
void set_color(short f,short b,char bright)
{
	//CURSES REQUIRES THAT THE COLOR
		//FOREGROUND: WHITE, BACKGROUND: BLACK	
			//BE IN THE ZERO,ZERO POSITION
	//SO I DO THIS SWAP TO KEEP THINGS CONSISTANT
	if(f==7&&b==0)
		{
		f=0;b=0;
		}
	else if(f==0&&b==0)
		{
		f=7;b=0;
		}

	//PICK COLOR PAIR BASED ON FOREGROUND AND BACKGROUND
	if(bright)attrset(A_BOLD | COLOR_PAIR(f*8+b));
	else
		{
		attrset(COLOR_PAIR(f*8+b));
		}
}

//IN CASE FUNKY ARROW KEYS ARE SENT IN, TRANSLATE THEM BACK
	//DON'T ACTUALLY USE THIS, SINCE I USED GetKeyState
		//TO TEST THE ARROWS
	//BUT THIS INFO CAN BE USEFUL
void translategetch(char &c)
{
	//ARROW PAD
	if(c==2)c='2';
	if(c==3)c='8';
	if(c==4)c='4';
	if(c==5)c='6';

	//KEYPAD WITH NUMLOCK OFF
	if(c==-63)c='7';
	if(c==-62)c='8';
	if(c==-61)c='9';
	if(c==-60)c='4';
	if(c==-59)c='5';
	if(c==-58)c='6';
	if(c==-57)c='1';
	if(c==-56)c='2';
	if(c==-55)c='3';

	//THE REST OF THE KEY PAD
	if(c==-6)c='0';
	if(c==-50)c='.';
	if(c==-53)c=10;
	if(c==-47)c='+';
	if(c==-48)c='-';
	if(c==-49)c='*';
	if(c==-54)c='/';
}

/////////////////////////////////////////////////////////////
//RANDOM NUMBER STUFF
/////////////////////////////////////////////////////////////
//the random number generator that came with MSVC, at least
//until recently, had a period of only 32000.  This is insufficient
//for many applications.  So I wrote this:

//picks a random number from 0 to max-1
unsigned long random(unsigned long max)
{
	r_num();

	long double rand_y;
	long double rand_i;

	rand_i = 2147483648L;

	rand_y = max*((long double)seed/rand_i);

	return((long)rand_y);
}

//sets seed to a random number from 0 to 2 billion
void r_num(void)
{
	seed=(seed*907725L+99979777L)%2147483648L;
}